#version 3.5;

/// MACROS

// duh...
#macro MakeLeaf()

  #declare LVecA = array[10] {<0,0,0>,<-2,0,0.2>,<0,1,0.3>,<-2,3.5,0.4>,<-3.5,1,0.4>,<-4.5,4.5,0.3>,<-2.5,5,0.1>,<0,5,0.4>,<0,8,0.2>,<-1.5,5,0.3>};
  
  
  #declare LeafA = mesh{

  triangle{LVecA[0],LVecA[1],LVecA[2]}
  triangle{LVecA[1],LVecA[2],LVecA[3]}
  triangle{LVecA[1],LVecA[3],LVecA[4]}
  triangle{LVecA[3],LVecA[4],LVecA[5]}
  triangle{LVecA[2],LVecA[3],LVecA[7]}
  triangle{LVecA[3],LVecA[6],LVecA[7]}
  triangle{LVecA[7],LVecA[8],LVecA[9]}

  triangle{LVecA[0]*<-1,1,1>,LVecA[1]*<-1,1,1>,LVecA[2]*<-1,1,1>}
  triangle{LVecA[1]*<-1,1,1>,LVecA[2]*<-1,1,1>,LVecA[3]*<-1,1,1>}
  triangle{LVecA[1]*<-1,1,1>,LVecA[3]*<-1,1,1>,LVecA[4]*<-1,1,1>}
  triangle{LVecA[3]*<-1,1,1>,LVecA[4]*<-1,1,1>,LVecA[5]*<-1,1,1>}
  triangle{LVecA[2]*<-1,1,1>,LVecA[3]*<-1,1,1>,LVecA[7]*<-1,1,1>}
  triangle{LVecA[3]*<-1,1,1>,LVecA[6]*<-1,1,1>,LVecA[7]*<-1,1,1>}
  triangle{LVecA[7]*<-1,1,1>,LVecA[8]*<-1,1,1>,LVecA[9]*<-1,1,1>}

  }
  #declare Leaf = union{
    object{LeafA}
    cylinder{0,y*-3,0.2}
    translate y*3
  }

#end


// makes a section of tree

#macro Cylinder_Object(CStart, CVec, CWidth, CAng, CLev)
  #local cylLen  = 4 * ((rand(myRand) + 0.5)/CLev);
  #local cylTran = transform{
    rotate x*(2 * CAng * rand(myRand) - CAng)
    rotate y*(360 * rand(myRand))
    Reorient_Trans(y * 1, CVec)
    translate CStart
  }
  #declare segPosB = vtransform(y * cylLen, cylTran);
  #declare segVec = segPosB - CStart;
  cylinder{
    0, y * cylLen, CWidth, 1
    transform{cylTran}
  }
#end


#macro Make_Tree(TArraySize, TSeed, TBWidth, THt, TCutoff, TBranch, TAng, TLevs)

  #declare PosArray = array[TArraySize];
  #declare VecArray = array[TArraySize];
  #declare WidArray = array[TArraySize];
  #declare LevArray = array[TArraySize];
  #declare LeafArray = array[TArraySize];
  #declare PosArray[0] = <0,0,0>;
  #declare VecArray[0] = <0,1,0>;
  #declare WidArray[0] = TBWidth;
  #declare LevArray[0] = 1;

  #declare checkCount = -1;
  #declare highCount  = 0;
  #declare myRand     = seed(TSeed);
  #declare myRand2    = seed(TSeed+345);
  #declare leafCount = 0;

  #declare Wood =
  blob{
    threshold 0.5
    #while (checkCount < highCount)
 
      #declare checkCount = checkCount + 1;
      #declare segPosA    = PosArray[checkCount];
      #declare segVec     = VecArray[checkCount];
      #declare segWidth   = WidArray[checkCount];
      #declare segLev     = LevArray[checkCount];
      #declare segPosB    = segPosA;
      #declare CarryOn    = true;

      #while(vlength(segPosB) < THt & segWidth > 0.01 & CarryOn)
        #declare segPosA = segPosB;
          #if(segLev >= TLevs & doLeaves)
            #declare LeafArray[leafCount] = segPosA;
            #declare leafCount = leafCount + 1;
          #end
          Cylinder_Object(segPosA, segVec, segWidth, TAng, segLev)
        #declare randNum = rand(myRand);
        #if(randNum > 1 - ((segLev*segLev)/250) | (segPosB.y < TCutoff & segLev > 1))
          #declare CarryOn = false;
        #end
        #if (randNum < (TBranch/(pow(segLev,0.25))) & segLev < TLevs & (segPosB.y > TCutoff | segLev > 1)) // & segPosB.z > -5 )
          #declare segWidth  = segWidth * 0.75;
          #declare highCount = highCount + 1;
          
          #declare PosArray[highCount] = segPosB;
          #declare VecArray[highCount] = segVec;
          #declare WidArray[highCount] = segWidth * 0.95;
          #declare LevArray[highCount] = segLev + 1;
        #end
      #end
    #end
  }
  
  #if(leafCount > 0)
  MakeLeaf()
  #declare LScale = 0.075;
  #debug concat("leafCount: ", str(leafCount,0,1),"\n")
    #declare Leaves = union{
      #declare leafPlacer = 0;
      #while(leafPlacer < leafCount)

        object{Leaf scale LScale rotate y*(90*rand(myRand2)-45) rotate x*(90 + (30*rand(myRand2))) rotate y*(360*rand(myRand2)) translate LeafArray[leafPlacer]}
        object{Leaf scale LScale rotate y*(90*rand(myRand2)-45) rotate x*(90 + (40*rand(myRand2))) rotate y*(360*rand(myRand2)) translate LeafArray[leafPlacer]}
        object{Leaf scale LScale rotate y*(90*rand(myRand2)-45) rotate x*(90 + (30*rand(myRand2))) rotate y*(360*rand(myRand2)) translate LeafArray[leafPlacer]}
        object{Leaf scale LScale rotate y*(90*rand(myRand2)-45) rotate x*(90 + (20*rand(myRand2))) rotate y*(360*rand(myRand2)) translate LeafArray[leafPlacer]}

        #declare leafPlacer = leafPlacer + 1;
      #end
    }
    #declare arrayPointer = int(rand(myRand)*5);
    #declare Tree = union{
      object{Wood texture{treeTex}}
      object{Leaves texture{leafTex[arrayPointer]}}
    }
  #else
    #declare Tree = object{Wood texture{treeTex}}
  #end
    
#end

#macro MakeWall(WallHi, WallStart, WallEnd, WallSeed)
  #declare Rand1 = seed(WallSeed);
  #declare BrickRand1 = seed(45968);
  #declare BestY = 0;
  #declare Count = 0;
  #declare WallGround = object{Ground};
  #declare Building = true;
  #while(Building)
  
    #declare XScale = rand(Rand1)*1/2 + 0.75;
    #declare YScale = rand(Rand1)*1/2 + 0.50; 
    #declare ZScale = rand(Rand1)*1/2 + 0.50;
    #declare WallBrick =
    blob{
      threshold 0.75
      sphere{0,2,1 scale<XScale, YScale, ZScale>}
      #declare BCount = 0;
      #while(BCount < 10)
        #declare BXRot = 360*rand(Rand1);
        #declare BYRot = 360*rand(Rand1);
        #declare BZRot = 360*rand(Rand1);
        #declare XScale = rand(Rand1)*1/2 + 0.5;
        #declare YScale = rand(Rand1)*1/2 + 0.5; 
        #declare ZScale = rand(Rand1)*1/2 + 0.5;
        sphere{
          0, 0.5+(rand(Rand1)/2), 1/2
          scale<XScale, YScale, ZScale>
          translate z*(0.25+(rand(Rand1)/4)) rotate<BXRot,BYRot,BZRot>
        }
        #declare BCount = BCount + 1;
      #end
      
      #declare XScale = rand(Rand1)*1/2 + 0.50;
      #declare YScale = rand(Rand1)*1/2 + 0.50; 
      #declare ZScale = rand(Rand1)*1/2 + 0.50;
      scale<XScale, YScale, ZScale>
    }

    #declare XScale = rand(Rand1)*1/4 + 0.75;
    #declare YScale = rand(Rand1)*1/2 + 0.5; 
    #declare ZScale = rand(Rand1)*1/2 + 0.5;

    #declare Brick = object{
      WallBrick scale<XScale, YScale, ZScale>
      texture{brickTexA[0] scale 1}
    }
    #declare BestY = 1000;
    #declare BestYG = -1000;
    #declare TraceX = WallStart;
    #while(TraceX <= WallEnd)
      #declare Start = <TraceX, 500, 0>; 
      #declare InterA = trace (WallGround, Start, <0, -1, 0>);
      #declare InterB = trace (Ground, Start, <0, -1, 0>);
      #if((InterA.y-InterB.y) < (BestY - BestYG))
          #declare BestX = InterA.x;
          #declare BestY = InterA.y;
          #declare BestYG = InterB.y;
      #end
      #if((InterA.y-InterB.y) > WallHi)
        #declare Building = false;
      #end
      #declare TraceX = TraceX + (2*XScale);
    #end
    #declare Count = Count + 1;
    #declare WallGround = union{
      object{WallGround}
      #declare YScale = YScale *((WallHi-(InterA.y-InterB.y))/(2*WallHi) + 0.50);
      #declare ZScale = ZScale * ((WallHi-(InterA.y-InterB.y))/(4*WallHi) + 0.75);
      object{Brick scale<1, YScale, ZScale> translate<BestX, BestY + YScale, 0>}
    }
    #ifdef(Wall)
      #declare Wall = union{
        object{Wall}
        object{Brick translate<BestX, BestY + YScale, 0> texture{brickTexA[0] scale 1}}
      }
    #else
      #declare Wall = object{Brick translate<BestX, BestY + YScale, 0> texture{brickTexA[0] scale 1}}
    #end
  #end
#end


