// Persistence of Vision Ray Tracer Scene Description File
// File: ?.pov
// Vers: 3.5
// Desc: Basic Scene Example
// Date: mm/dd/yy
// Auth: ?
//

#version 3.5;

#include "colors.inc"
#include "functions.inc"

// first grass

#include "mgrass.pov"
#declare lPatch=10;               // size of patch
//#declare nBlade=4;                // number of blades per line (there will be nBlade x nBlade blades)
#declare nBlade=40;                // number of blades per line (there will be nBlade x nBlade blades)
#declare ryBlade = 0;            // initial y rotation of blade
#declare segBlade= 15;            // number of blade segments
#declare lBlade = 2.5;             // length of blade
#declare wBlade = 0.1;              // width of blade at start
#declare wBladeEnd = 0.03;         // width of blade at the end
#declare doSmooth=false;          // true makes smooth triangles
#declare startBend = <0,1,0.3>;   // bending of blade at start (<0,1,0>=no bending)
#declare vBend = <0,-0.5,0>;         // force bending the blade (<0,1,1> = 45)
#declare pwBend = 3;              // bending power (how slowly the curve bends)
#declare rd = 459;                // seed
#declare stdposBlade = 1;         // standard deviation of blade position 0..1
#declare stdrotBlade = 360;       // standard deviation of rotation
#declare stdBlade = 1.2;           // standard deviation of blade scale;
#declare stdBend = 2;            // standard deviation of blade bending;
#declare dofold = true;          // true creates a central fold in the blade (twice more triangles)
#declare fname = "tomgrass1.inc"     // name of the mesh file to create
  
#if(dofile)
  MakeGrassPatch(lPatch,nBlade,ryBlade,segBlade,lBlade,wBlade,wBladeEnd,doSmooth,startBend,vBend,pwBend,rd,stdposBlade,stdrotBlade,stdBlade,stdBend,dofold,dofile,fname)
#end
#declare GrassPatch1 = #include "tomgrass1.inc"

// second dead grass

#declare lPatch=10;               // size of patch
//#declare nBlade=4;                // number of blades per line (there will be nBlade x nBlade blades)
#declare nBlade=40;                // number of blades per line (there will be nBlade x nBlade blades)
#declare ryBlade = 0;            // initial y rotation of blade
#declare segBlade= 15;            // number of blade segments
#declare lBlade = 1.75;             // length of blade
#declare wBlade = 0.1;              // width of blade at start
#declare wBladeEnd = 0.03;         // width of blade at the end
#declare doSmooth=false;          // true makes smooth triangles
#declare startBend = <0,1,0.3>;   // bending of blade at start (<0,1,0>=no bending)
#declare vBend = <0,-0.5,0>;         // force bending the blade (<0,1,1> = 45)
#declare pwBend = 3;              // bending power (how slowly the curve bends)
#declare rd = 729;                // seed
#declare stdposBlade = 1;         // standard deviation of blade position 0..1
#declare stdrotBlade = 360;       // standard deviation of rotation
#declare stdBlade = 1.2;           // standard deviation of blade scale;
#declare stdBend = 3;            // standard deviation of blade bending;
#declare dofold = false;          // true creates a central fold in the blade (twice more triangles)
#declare fname = "tomgrass2.inc"     // name of the mesh file to create
  
#if(dofile)
  MakeGrassPatch(lPatch,nBlade,ryBlade,segBlade,lBlade,wBlade,wBladeEnd,doSmooth,startBend,vBend,pwBend,rd,stdposBlade,stdrotBlade,stdBlade,stdBend,dofold,dofile,fname)
#end
#declare GrassPatch2 = #include "tomgrass2.inc"

// third tall grass

#declare lPatch=20;               // size of patch
//#declare nBlade=4;                // number of blades per line (there will be nBlade x nBlade blades)
#declare nBlade=2;                // number of blades per line (there will be nBlade x nBlade blades)
#declare ryBlade = 0;            // initial y rotation of blade
#declare segBlade= 15;            // number of blade segments
#declare lBlade = 25;             // length of blade
#declare wBlade = 0.1;              // width of blade at start
#declare wBladeEnd = 0.1;         // width of blade at the end
#declare doSmooth=true;          // true makes smooth triangles
#declare startBend = <0,1,0.5>;   // bending of blade at start (<0,1,0>=no bending)
#declare vBend = <0,0,1>;         // force bending the blade (<0,1,1> = 45)
#declare pwBend = 3;              // bending power (how slowly the curve bends)
#declare rd = 959;                // seed
#declare stdposBlade = 1;         // standard deviation of blade position 0..1
#declare stdrotBlade = 360;       // standard deviation of rotation
#declare stdBlade = 3;           // standard deviation of blade scale;
#declare stdBend = 2;            // standard deviation of blade bending;
#declare dofold = false;          // true creates a central fold in the blade (twice more triangles)
#declare fname = "tomgrass3.inc"     // name of the mesh file to create
  
#if(dofile)
  MakeGrassPatch(lPatch,nBlade,ryBlade,segBlade,lBlade,wBlade,wBladeEnd,doSmooth,startBend,vBend,pwBend,rd,stdposBlade,stdrotBlade,stdBlade,stdBend,dofold,dofile,fname)
#end
#declare GrassPatch3 = #include "tomgrass3.inc"


#declare pigEarth =
texture{
  pigment{rgb<0.1,0.2,0.0>}
}

#declare txtGrass1 =
texture{
  pigment{rgb<75,125,10>/255}
  finish{specular 0.25 roughness 0.01 diffuse 0.8}
}

#declare txtGrass2 =
texture{
  pigment{rgb<200,180,50>/255}
  finish{diffuse 0.8}
}

#declare txtGrass3 =
texture{
  pigment{rgb<180,180,50>/255}
  finish{diffuse 0.8}
}


#declare GrassPatchA =
union{
  object{GrassPatch1 texture{txtGrass1}}
  object{GrassPatch2 texture{txtGrass2}}
  object{GrassPatch3 texture{txtGrass3}}
  box{-5,<5,0,5> texture{pigEarth}}
  scale 0.2
}

#declare GrassPatchB =
union{
  object{GrassPatch1 texture{txtGrass1}}
  object{GrassPatch2 texture{txtGrass2}}
  box{-5,<5,0,5> texture{pigEarth}}
  scale 0.2
}
