#version 3.5;
#include "colors.inc"


// Tree Texture (bark)

#declare treeTex =
texture{
  pigment{
    dents scale 1 turbulence 0.25 // scale was 0.75
    pigment_map{
      [0.03 rgb<0.25,0.25,0.15>]
      [0.06 bozo pigment_map{[0 rgb<0.45,0.40,0.20>][0.5 rgb<0.25,0.25,0.15>][1 rgb<0.45,0.45,0.20>]}]
      [0.27 bozo pigment_map{[0 rgb<0.45,0.40,0.20>][0.5 rgb<0.25,0.25,0.15>][1 rgb<0.45,0.45,0.20>]}]
      [0.30 granite scale 0.5 pigment_map{[0 rgb<0.90,0.75,0.45>][1 rgb<0.85,0.85,0.35>]}]
    }
  }
  normal{
    dents scale 1 turbulence 0.25
    normal_map{
      [0.04 average normal_map{[granite 20 scale 0.25][agate 20 scale 0.5][bozo 15 scale 0.25]}]
      [0.04 average normal_map{[granite 0.5 scale 0.25][crackle 3 scale 0.03]}]
      [0.20 average normal_map{[granite 0.5 scale 0.25][crackle 3 scale 0.03]}]
      [0.25 agate 15 scale 0.50]
      [0.30 granite 0.2 scale 0.25]
    }
  }
  finish{
    diffuse 0.7
    specular 0.15
    roughness 0.1
  }
}


// Rock Texture


#declare brickFinish =
finish{
  diffuse 0.7
  specular 0.05
  roughness 0.5
}

#declare brickNorm =
normal{
  average
  normal_map{
    [dents   5.0 scale 0.5]
    [agate   2.0 scale 1.0]
    [granite 0.1 scale 0.5]
  }
}

#declare brickTex1 =

texture{
  pigment{
    granite scale 0.5
    pigment_map{
      [0.0 rgb 0.5]
      [0.5 rgb 0.2]
      [1.0 rgb 0.4]
    }
  }
  normal{brickNorm}
  finish{brickFinish}
}

texture{
  pigment{
    wrinkles turbulence 0.1 scale 0.2
    pigment_map{
      [0.3 rgbf 1]
      [0.4 wrinkles scale 0.1 pigment_map{[0.25 rgbf<0.8,0.8,0.8,0.5>][0.75 rgbf 1]}]
      [0.5 rgbf 1]
      [0.6 rgbf 1]
      [0.7 wrinkles scale 0.1 pigment_map{[0.5 rgbf<0.6,0.6,0.6,0.5>][0.75 rgbf 1]}]
      [0.8 rgbf 1]
    }
  }
  normal{brickNorm}
  finish{brickFinish}
}

texture{
  pigment{
    agate scale 1/6 pigment_map{
      [0.25 rgbf 1]
      [0.75 rgbf<0.4,0.5,0.2,0.75>]
    }
  }
  normal{average normal_map{[granite 5 scale 0.5][bozo 2 scale 0.25]}}
  finish{diffuse 0.7}
}

#declare brickTexA = array[1]{brickTex1};

/*
// Grass Texture

#declare Blanc1=rgb<0.90,0.81,0.81>;
#declare Green1=rgb<0.3,0.6,0.2>*0.5; //.3
#declare Green2=rgb<40,100,8>/155;  ///355
#declare pigEarth =pigment {
  spotted
  color_map {
    [0 color Tan*0.3]
    [0.6 color Tan*0.3]
    [0.6 color Green1*0.4]
    [1   color Green1*0.4]
  }
}

#declare pigSpotted =pigment {
  spotted
  color_map {
    [0.0, 0.2   color Tan*0.1 color Tan*0.4]
    [0.2, 0.3   color Tan*0.4 color Green1]
    [0.3, 1.01   color Green1 color Green1*1.2]
  }
}

#declare pigGreen=pigment{Green2*1.5}
#declare txtGrass=texture {                  
  pigment {
    gradient y
    turbulence 0.2
    pigment_map {                                
        [0.0 pigEarth]
        [0.3 pigGreen]
        [0.9 pigSpotted]
        [1.00 pigEarth]
    }
  }
  finish{ambient 0.01 diffuse 0.7 specular 0.2 roughness 0.015}
  scale <0.001,1,0.001>
} 

// Leaf Texture
*/

#declare leafTex = array[5];

#declare leafTex[0] = texture{pigment{rgbf<0.4,0.8,0.2,0.25>} normal{agate scale 0.5} finish{diffuse 0.8 specular 0.25 roughness 0.05}};
#declare leafTex[1] = texture{pigment{rgbf<0.6,0.7,0.2,0.25>} normal{agate scale 0.5} finish{diffuse 0.7 specular 0.25 roughness 0.10}};
#declare leafTex[2] = texture{pigment{rgbf<0.5,0.6,0.2,0.25>} normal{agate scale 0.5} finish{diffuse 0.6 specular 0.25 roughness 0.07}};
#declare leafTex[3] = texture{pigment{rgbf<0.7,0.7,0.2,0.25>} normal{agate scale 0.5} finish{diffuse 0.8 specular 0.25 roughness 0.10}};
#declare leafTex[4] = texture{pigment{rgbf<0.3,0.9,0.2,0.25>} normal{agate scale 0.5} finish{diffuse 0.9 specular 0.25 roughness 0.04}};
